/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Dropdown } from "./Dropdown";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SelectDir_$type } from "./SelectDir";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
var Select = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.focus = null;
        _this.blur = null;
        return _this;
    }
    Object.defineProperty(Select.prototype, "ak", {
        get: function () {
            var ret_ = this.i.m("value");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("value", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ai", {
        get: function () {
            var ret_ = this.i.m("name");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("name", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ad", {
        get: function () {
            var ret_ = this.i.m("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ag", {
        get: function () {
            var ret_ = this.i.m("required");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("required", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ae", {
        get: function () {
            var ret_ = this.i.m("invalid");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("invalid", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "af", {
        get: function () {
            var ret_ = this.i.m("outlined");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("outlined", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ac", {
        get: function () {
            var ret_ = this.i.m("autofocus");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("autofocus", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "ah", {
        get: function () {
            var ret_ = this.i.m("label");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("label", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "aj", {
        get: function () {
            var ret_ = this.i.m("placeholder");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.i.u("placeholder", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Select.prototype, "z", {
        get: function () {
            var ret_ = this.i.m("dir");
            ret_ = enumGetBox(SelectDir_$type, EnumUtil.getEnumValue(SelectDir_$type, this.i.f(SelectDir_$type, ret_)));
            return EnumUtil.getEnumValue(SelectDir_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SelectDir_$type, a);
            value_ = WCNativeHelper.o(value_.toString());
            this.i.u("dir", value_);
        },
        enumerable: false,
        configurable: true
    });
    Select.prototype.focusChanged = function () {
        var _this = this;
        if (this.focus != null) {
            this.i.q("focus", function (a) { return _this.focus(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.i.t("focus");
        }
    };
    Select.prototype.blurChanged = function () {
        var _this = this;
        if (this.blur != null) {
            this.i.q("blur", function (a) { return _this.blur(_this, VoidEventArgs.b(a)); });
        }
        else {
            this.i.t("blur");
        }
    };
    Select.prototype.ap = function (a) {
        this.nativeElement.focus(this.i.h(a));
    };
    Select.prototype.am = function () {
        this.nativeElement.blur();
    };
    Select.prototype.aq = function () {
        this.nativeElement.reportValidity();
    };
    Select.prototype.an = function () {
        this.nativeElement.checkValidity();
    };
    Select.$t = markType(Select, 'Select', Dropdown.$);
    return Select;
}(Dropdown));
export { Select };
