/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ComboDir_$type } from "./ComboDir";
import { GroupingDirection_$type } from "./GroupingDirection";
import { FilteringOptions } from "./FilteringOptions";
import { ComboChangeEventArgs } from "./ComboChangeEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
/**
 * @hidden
 */
export let Combo = /*@__PURE__*/ (() => {
    class Combo extends BaseElement {
        constructor() {
            super(...arguments);
            this.n = new WCNativeHelper();
            this.z = null;
            this.change = null;
            this.focus = null;
            this.blur = null;
            this.opening = null;
            this.opened = null;
            this.closing = null;
            this.closed = null;
            this.ac = null;
            this.ab = null;
        }
        get o() {
            return this.n;
        }
        get nativeElement() {
            return this.z;
        }
        set nativeElement(a) {
            this.z = a;
            this.n.n = this.z;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.o.m("data");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.o.u("data", value_);
        }
        get ag() {
            let ret_ = this.o.m("name");
            return ret_;
        }
        set ag(a) {
            let value_ = a;
            this.o.u("name", value_);
        }
        get s() {
            let ret_ = this.o.m("disabled");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.o.u("disabled", value_);
        }
        get x() {
            let ret_ = this.o.m("required");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.o.u("required", value_);
        }
        get u() {
            let ret_ = this.o.m("invalid");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.o.u("invalid", value_);
        }
        get w() {
            let ret_ = this.o.m("outlined");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.o.u("outlined", value_);
        }
        get y() {
            let ret_ = this.o.m("singleSelect");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.o.u("singleSelect", value_);
        }
        get p() {
            let ret_ = this.o.m("autofocus");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.o.u("autofocus", value_);
        }
        get q() {
            let ret_ = this.o.m("autofocusList");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.o.u("autofocusList", value_);
        }
        get af() {
            let ret_ = this.o.m("label");
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.o.u("label", value_);
        }
        get ah() {
            let ret_ = this.o.m("placeholder");
            return ret_;
        }
        set ah(a) {
            let value_ = a;
            this.o.u("placeholder", value_);
        }
        get ai() {
            let ret_ = this.o.m("placeholderSearch");
            return ret_;
        }
        set ai(a) {
            let value_ = a;
            this.o.u("placeholderSearch", value_);
        }
        get e() {
            let ret_ = this.o.m("dir");
            ret_ = enumGetBox(ComboDir_$type, EnumUtil.getEnumValue(ComboDir_$type, this.o.f(ComboDir_$type, ret_)));
            return EnumUtil.getEnumValue(ComboDir_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(ComboDir_$type, a);
            value_ = WCNativeHelper.o(value_.toString());
            this.o.u("dir", value_);
        }
        get v() {
            let ret_ = this.o.m("open");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.o.u("open", value_);
        }
        get aj() {
            let ret_ = this.o.m("valueKey");
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.o.u("valueKey", value_);
        }
        get ad() {
            let ret_ = this.o.m("displayKey");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.o.u("displayKey", value_);
        }
        get ae() {
            let ret_ = this.o.m("groupKey");
            return ret_;
        }
        set ae(a) {
            let value_ = a;
            this.o.u("groupKey", value_);
        }
        get g() {
            let ret_ = this.o.m("groupSorting");
            ret_ = enumGetBox(GroupingDirection_$type, EnumUtil.getEnumValue(GroupingDirection_$type, this.o.f(GroupingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(GroupingDirection_$type, ret_);
        }
        set g(a) {
            let value_ = enumGetBox(GroupingDirection_$type, a);
            value_ = WCNativeHelper.o(value_.toString());
            this.o.u("groupSorting", value_);
        }
        get f() {
            let ret_ = this.o.l("filteringOptions", (a) => new FilteringOptions());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.o.u("filteringOptions", value_);
        }
        get r() {
            let ret_ = this.o.m("caseSensitiveIcon");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.o.u("caseSensitiveIcon", value_);
        }
        get t() {
            let ret_ = this.o.m("disableFiltering");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.o.u("disableFiltering", value_);
        }
        get c() {
            let ret_ = this.o.m("value");
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.o.u("value", value_);
        }
        get b() {
            let ret_ = this.o.m("selection");
            return ret_;
        }
        changeChanged() {
            if (this.change != null) {
                this.o.q("change", (a) => this.change(this, ComboChangeEventArgs.a(a)));
            }
            else {
                this.o.t("change");
            }
        }
        focusChanged() {
            if (this.focus != null) {
                this.o.q("focus", (a) => this.focus(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.t("focus");
            }
        }
        blurChanged() {
            if (this.blur != null) {
                this.o.q("blur", (a) => this.blur(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.t("blur");
            }
        }
        openingChanged() {
            if (this.opening != null) {
                this.o.q("opening", (a) => this.opening(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.t("opening");
            }
        }
        openedChanged() {
            if (this.opened != null) {
                this.o.q("opened", (a) => this.opened(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.t("opened");
            }
        }
        closingChanged() {
            if (this.closing != null) {
                this.o.q("closing", (a) => this.closing(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.t("closing");
            }
        }
        closedChanged() {
            if (this.closed != null) {
                this.o.q("closed", (a) => this.closed(this, VoidEventArgs.b(a)));
            }
            else {
                this.o.t("closed");
            }
        }
        aw() {
            this.nativeElement.reportValidity();
        }
        an() {
            this.nativeElement.checkValidity();
        }
        as(a) {
            this.nativeElement.focus(this.o.h(a));
        }
        al() {
            this.nativeElement.blur();
        }
        ax(a) {
            this.nativeElement.select(this.o.h(a));
        }
        aq(a) {
            this.nativeElement.deselect(this.o.h(a));
        }
        az() {
            this.nativeElement.show();
        }
        at() {
            this.nativeElement.hide();
        }
        a0() {
            this.nativeElement.toggle();
        }
    }
    Combo.$t = /*@__PURE__*/ markType(Combo, 'Combo', BaseElement.$);
    return Combo;
})();
