/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ButtonBase } from "./ButtonBase";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { IconButtonVariant_$type } from "./IconButtonVariant";
/**
 * @hidden
 */
export let IconButton = /*@__PURE__*/ (() => {
    class IconButton extends ButtonBase {
        get y() {
            let ret_ = this.h.m("name");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.h.u("name", value_);
        }
        get x() {
            let ret_ = this.h.m("collection");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.h.u("collection", value_);
        }
        get w() {
            let ret_ = this.h.m("mirrored");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.h.u("mirrored", value_);
        }
        get v() {
            let ret_ = this.h.m("variant");
            ret_ = enumGetBox(IconButtonVariant_$type, EnumUtil.getEnumValue(IconButtonVariant_$type, this.h.f(IconButtonVariant_$type, ret_)));
            return EnumUtil.getEnumValue(IconButtonVariant_$type, ret_);
        }
        set v(a) {
            let value_ = enumGetBox(IconButtonVariant_$type, a);
            value_ = WCNativeHelper.o(value_.toString());
            this.h.u("variant", value_);
        }
        z(a, b, c) {
            this.nativeElement.registerIcon(this.h.h(a), this.h.h(b), this.h.h(c));
        }
        aa(a, b, c) {
            this.nativeElement.registerIconFromText(this.h.h(a), this.h.h(b), this.h.h(c));
        }
    }
    IconButton.$t = /*@__PURE__*/ markType(IconButton, 'IconButton', ButtonBase.$);
    return IconButton;
})();
