/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { ChipVariant_$type } from "./ChipVariant";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { ComponentBoolValueChangedEventArgs } from "./ComponentBoolValueChangedEventArgs";
/**
 * @hidden
 */
var Chip = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Chip, _super);
    function Chip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = new WCNativeHelper();
        _this.k = null;
        _this.remove = null;
        _this.select = null;
        return _this;
    }
    Object.defineProperty(Chip.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Chip.prototype, "nativeElement", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            this.k = a;
            this.e.n = this.k;
        },
        enumerable: false,
        configurable: true
    });
    Chip.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Chip.prototype, "g", {
        get: function () {
            var ret_ = this.f.m("disabled");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.u("disabled", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Chip.prototype, "h", {
        get: function () {
            var ret_ = this.f.m("removable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.u("removable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Chip.prototype, "i", {
        get: function () {
            var ret_ = this.f.m("selectable");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.u("selectable", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Chip.prototype, "j", {
        get: function () {
            var ret_ = this.f.m("selected");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.f.u("selected", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Chip.prototype, "a", {
        get: function () {
            var ret_ = this.f.m("variant");
            ret_ = enumGetBox(ChipVariant_$type, EnumUtil.getEnumValue(ChipVariant_$type, this.f.f(ChipVariant_$type, ret_)));
            return EnumUtil.getEnumValue(ChipVariant_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(ChipVariant_$type, a);
            value_ = WCNativeHelper.o(value_.toString());
            this.f.u("variant", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Chip.prototype, "d", {
        get: function () {
            var ret_ = this.f.m("size");
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.f.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.o(value_.toString());
            this.f.u("size", value_);
        },
        enumerable: false,
        configurable: true
    });
    Chip.prototype.removeChanged = function () {
        var _this = this;
        if (this.remove != null) {
            this.f.q("remove", function (a) { return _this.remove(_this, ComponentBoolValueChangedEventArgs.a(a)); });
        }
        else {
            this.f.t("remove");
        }
    };
    Chip.prototype.selectChanged = function () {
        var _this = this;
        if (this.select != null) {
            this.f.q("select", function (a) { return _this.select(_this, ComponentBoolValueChangedEventArgs.a(a)); });
        }
        else {
            this.f.t("select");
        }
    };
    Chip.$t = markType(Chip, 'Chip', BaseElement.$);
    return Chip;
}(BaseElement));
export { Chip };
